######################################################################################	
# Gladiator Mod Configuration 
# by Josh Dahlby
######################################################################################	


# Settings
MusicDir = "DEFAULT"
SelectedEnemies = []
LastLevel = "Arena1"
InvisibleEnemies = 1
MaxEnemies = 3
PlayerName = "BLADE"
try:
	execfile("../../Config/gladiator.cfg")
except:
	pass

def SaveConfiguration():
	cfgfile = open("../../Config/gladiator.cfg", "w")
	cfgfile.write('MusicDir = "' + str(MusicDir) + '"\n')
	cfgfile.write('SelectedEnemies = ' + str(SelectedEnemies) + '\n')
	cfgfile.write('LastLevel = "' + str(LastLevel) + '"\n')
	cfgfile.write('InvisibleEnemies = ' + str(InvisibleEnemies) + '\n')
	cfgfile.write('MaxEnemies = ' + str(MaxEnemies) + '\n')
	cfgfile.write('PlayerName = "' + str(PlayerName) + '"\n')
	cfgfile.close()

# Map variables
playerPosition = (0, 0, 0)
playerAngle = 0.0
weaponPosition = None
excludeEnemies = []
positionFunc = None
randomPositions = 0
spawnPositions = [{"Position": (0, 0, 0), "Angle": 0.0}]
level = None

# Player save info
PlayerScore = (0, 0, 0, 0)
PlayerData = None

def WritePlayer(name, score, data):
	import os
	if not os.path.exists("../../Save/gladiator"):
		os.mkdir("../../Save/gladiator")
	cfgfile = open("../../Save/gladiator/" + name + ".sav", "w")
	cfgfile.write('global PlayerScore\n')
	cfgfile.write('global PlayerData\n')
	cfgfile.write('PlayerScore = ' + str(score) + '\n')
	cfgfile.write('PlayerData = ' + str(data) + '\n')
	cfgfile.close()

def SaveNewPlayer(name, type, model):
	import NetMisc
	import CharStats
	PlayerTemplate = "({'Kind': '%s', 'Position': (0, 0, 0), 'Name': 'Player1'}, {'Armor': ('%s', 0, 0), 'ObjectsTaken': [], 'Saves': 0, 'Energy': %d, 'Level': 0, 'PartialLevel': 0, 'PViewType': 1, 'Combos': [], 'Life': %d}, {'InvLeftBack': None, 'Shields': [], 'SpecialKeys': [], 'InvLeft2': None, 'InvRightBack': None, 'Objects': [], 'Quivers': [], 'Weapons': [], 'InvRight': None, 'Tablets': [], 'Keys': [], 'maxWeapons': 4, 'InvLeft': None})"
	stype = NetMisc.Caracteres[type][1]
	smodel = NetMisc.Caracteres[type][model+2]
	life = CharStats.GetCharMaxLife(stype, 0)
	energy = CharStats.GetCharMaxEnergy(stype, 0)
	WritePlayer(name, (0, 0, 0, 0), PlayerTemplate %(stype, smodel, energy, life))

def SavePlayer(player, kills=0, deaths=0, score=0, round=0):
	name = None
	try:
		name = player.Data.SaveName
	except:
		return
	if name == None:
		return

	import GotoMapVars
	import MemPersistence
	import Bladex
	ent_state = GotoMapVars.MainCharState('Player1')
	props = ent_state.GetProps()
	props[1]["Life"] = player.Life
	MemPersistence.Store('MainChar',props)
	WritePlayer(name, (kills, deaths, score, round), MemPersistence.Get('MainChar'))
	Bladex.DeleteStringValue('MainChar')

def GetPlayerInfo(name):
	if name == '<Current>':
		import GotoMapVars
		return GotoMapVars.MainCharState('Player1').GetProps()
	else:
		execfile("../../Save/gladiator/" + name + ".sav")
		return PlayerData

def LoadPlayerInfo(name):
	global PlayerScore
	global PlayerData
	PlayerScore = (0,0,0,0)
	PlayerData = GetPlayerInfo(name)
	if (PlayerData != None):
		import MemPersistence
		import GotoMapVars
		import Bladex

		MemPersistence.Store('MainChar', PlayerData)
		GotoMapVars.RestoreMainCharState('MainChar')
		Bladex.DeleteStringValue('MainChar')
		player = Bladex.GetEntity(PlayerData[0]['Name'])
		player.Data.SaveName = name
